#include <stdlib.h>
#include <string.h>
#include <stdio.h>

typedef struct litem_t {
	 /* ... */
} litem;

typedef struct llist_t {
    struct litem_t *item;
    struct llist_t *next;
} llist;



llist *addItem(llist * alist, char *orderno, char *name, float price,
	       int count, float sum)
{
    /*...*/
    return alist;
}


void dumpList(llist * alist)
{
   /* ... */ 
}


#define BUFSIZE 1024

char* getstrdelim(char delim, FILE *pFile){
       
	char* buf = calloc(BUFSIZE,sizeof(char)); 
	size_t pos=0;
	while (pos<BUFSIZE){
      buf[pos] = fgetc(pFile);
	  if (buf[pos]==delim || feof(pFile)!=0 ){
		  if (pos==0){
			  free(buf);
			  return NULL;
		  }
		  buf[pos]='\0';

		  //remove leading and trailing spaces:
		  size_t start=0; size_t end=pos;

		  int c=0;
		  while(start<end && c < pos){
			  if (buf[start]==' '){
				  start++;
			  }
			  if (buf[end-1]==' '){
				  end--;
			  }
			  c++;
		  }

          buf[end]='\0';
		  char *ret = strdup(buf+start);


		  free(buf);
		  return ret;
	  }
	  pos++;
	}
    return NULL;

}

llist *readFile(const char *filename, llist * alist)
{

    FILE *pFile = fopen(filename, "r");
    if (NULL == pFile) {
	  fprintf(stderr, "cannot open file %s \n", filename);
    } else {
	char *buf = NULL;
    size_t r=0; 
    int token=0;
	char* orderno = NULL;
	char* name = NULL;
    float price=0;
	int count=0;
    char delim = ',' ;
    float sum=0;

	while(buf = getstrdelim(delim,pFile)){
          
		  switch(token){
			  	case 0: orderno=strdup(buf);
		                token++;
						break;
			  	case 1: name=strdup(buf);
		                token++;
						break;
				case 2: price = strtof(buf, NULL);
		                token++;
						break;
				case 3: count = strtol(buf, NULL, 10);
						delim='\n';
		                token++;
						break;
                case 4: sum = strtof(buf, NULL);
		                delim=','; //reset delimiter.
						token=0;
                 /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
						alist = addItem(alist,orderno,name,price,count,sum);
                 /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

						free (orderno);
						free (name);
						orderno=NULL;
						name=NULL;
						break;
		  }
		  free(buf);
	}

	free(orderno);
	free(name);

    }

    fclose(pFile);
    return alist;
}

int main(int argc, char **argv)
{

    llist *alist;
    alist = readFile("bestellung.csv", alist);
    /* ... */
    dumpList(alist);
    /* ... */

}
